function Tprime=HEX(t,X,U)

N=10;

cph=1030;           %[J/kgC]
cpc=1030;           %[J/kgC]
cp_w=800;           %[J/kgC]

% Heat transfer areas given from Perstorp [m^2]

A  = 115;
Ac = A/N;
Ah = A/N;
A_i_w=A/N;


% Volumes given from Perstorp [m^3]
Vh_tot = 2.3;       % Hot side volume [m3] for HE2 and HE3
Vc_tot = 1.8;       % Cold side volume [m3] for HE2 and HE3

Vh     = Vh_tot/N;
Vc     = Vc_tot/N;

hc     = 14;        %[W/m2K]
hh     = hc;        %[W/m2K]

mhex=2400;          %[kg]
mw  =mhex/N;

P=1;                %[atm]
M=0.029;            %[kg/mol]
R=8.2057*10^-5;     %[M3atm/Kmol]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Splitting the states
Th=X(1:N);
Tc=X(N+1:2*N);
Tw=X(2*N+1:3*N);                         

% Inputs and disturbances
Tc0      = U(1);                            % Inlet temp. cold side
Th0      = U(2);                            % Inlet temp. hot side
m        = U(3);                            % Mass flow 
a        = U(4);                            % Hot side bypass


dThdt=zeros(N,1);
dTcdt=zeros(N,1);
dTwdt=zeros(N,1);


rho_h=1;
rho_c=1;



% Initial
    dTcdt(1) =     (Tc0-Tc(1))*((m*R*(Tc(1)+273.15))/(P*M*Vc)) ...
                    - (Tc(1)-Tw(N))*(hc*Ac*R*(Tc(1)+273.15)/(cpc*P*M*Vc));
    
    dThdt(1) =     (Th0-Th(1))*((m*R*(Th(1)+273.15))/(P*M*Vh))...
                    - (Th(1)-Tw(1))*(hh*Ah*R*(Th(1)+273.15)/(cph*P*M*Vh));


    dTwdt(1) =     ((Th(1)-Tw(1))*hh  +  (Tc(N)-Tw(1))*hc)*(A_i_w/(mw*cp_w));

   

% Interior

for i=2:N
    
    
    
   dTcdt(i) =     (Tc(i-1)-Tc(i))*((m*R*(Tc(i)+273.15))/(P*M*Vc))...
                   -  (Tc(i)-Tw(N+1-i))*(hc*Ac*R*(Tc(i)+273.15)/(cpc*P*M*Vc));
   
   dThdt(i) =     (Th(i-1)-Th(i))*((m*R*(Th(i)+273.15))/(P*M*Vh))...
                    - (Th(i)-Tw(i))*(hh*Ah*R*(Th(i)+273.15)/(cph*P*M*Vh));

   dTwdt(i) =      ((Th(i)-Tw(i))*hh  +  (Tc(N+1-i)-Tw(i))*hc)*(A_i_w/(mw*cp_w));

end


Tprime=[dThdt; dTcdt; dTwdt];
end
